// Kleros
export var MISSING_PARAMETERS = function MISSING_PARAMETERS(name) {
  return 'Missing required parameter: ' + name;
};

// StoreProviderWrapper
export var PROFILE_NOT_FOUND = function PROFILE_NOT_FOUND(user) {
  return 'No profile found for user: ' + user + '.';
};
export var NOTIFICATION_NOT_FOUND = function NOTIFICATION_NOT_FOUND(txHash) {
  return 'No notification with txHash ' + txHash + ' exists.';
};
export var REQUEST_FAILED = function REQUEST_FAILED(error) {
  return 'Request returned an error response: ' + error;
};

// Contracts
export var UNABLE_TO_DEPLOY_CONTRACT = 'Unable to deploy contract, are you sure the contract artifact is correct?';
export var CONTRACT_NOT_DEPLOYED = 'Unable to load contract. Are you sure the contract is deployed and you are on the right network?';
export var UNABLE_TO_LOAD_CONTRACT = 'Unable to load contract. Are you sure the contract artifact is correct?';
export var MISSING_CONTRACT_PARAMETERS = 'Unable to load contract. Missing contractAddress or Artifact. Please call setContractInstance';

// Implementation
export var CONTRACT_INSTANCE_NOT_SET = 'No contract instance. Use setContractInstance';

// PinakionPOC
export var UNABLE_TO_SET_KLEROS = 'Unable to set Kleros.';
export var UNABLE_TO_TRANSFER_OWNERSHIP = 'Unable to transfer ownership.';

// KlerosPOC
export var UNABLE_TO_BUY_PNK = 'Unable to buy PNK, are you sure you have enough ETH?';
export var UNABLE_TO_ACTIVATE_PNK = 'Unable to activate PNK, are you sure you have enough?';
export var UNABLE_TO_FETCH_ARBITRATION_COST = 'Unable to fetch arbitration cost.';
export var UNABLE_TO_FETCH_APPEAL_COST = 'Unable to fetch appeal cost.';
export var UNABLE_TO_FETCH_TIME_PER_PERIOD = 'Unable to fetch time per period';
export var UNABLE_TO_PASS_PERIOD = 'Unable to pass period.';
export var UNABLE_TO_FETCH_DISPUTE = 'Unable to fetch dispute.';
export var UNABLE_TO_FETCH_AMOUNT_OF_JURORS = 'Unable to fetch amount of jurors';
export var UNABLE_TO_SUBMIT_VOTES = 'Unable to submit votes.';
export var UNABLE_TO_APPEAL = 'Unable to appeal.';
export var UNABLE_TO_REPARTITION_TOKENS = 'Unable to repartition tokens.';
export var UNABLE_TO_EXECUTE_RULING = 'Unable to execute ruling.';
export var ACCOUNT_NOT_A_JUROR_FOR_CONTRACT = function ACCOUNT_NOT_A_JUROR_FOR_CONTRACT(account, contractAddress) {
  return account + ' is not a juror for contract ' + contractAddress;
};
export var PERIOD_OUT_OF_RANGE = function PERIOD_OUT_OF_RANGE(periodNumber) {
  return 'Period ' + periodNumber + ' does not have a time associated with it.';
};
export var DISPUTE_DOES_NOT_EXIST = function DISPUTE_DOES_NOT_EXIST(disputeID) {
  return 'Dispute ' + disputeID + ' does not exist';
};

// ArbitrableTransaction
export var UNABLE_TO_CREATE_TRANSACTION = 'Unable to create a new transaction.';
export var UNABLE_TO_PAY_ARBITRATION_FEE = 'Unable to pay fee, are you sure you have enough PNK?';
export var UNABLE_TO_RAISE_AN_APPEAL = 'Unable to raise appeal, are you sure you are in the appeal period?';
export var UNABLE_TO_PAY_SELLER = 'Unable to pay the seller, are you sure you have enough ETH?';
export var UNABLE_TO_REIMBURSE_BUYER = 'Unable to reimburse the buyer.';
export var UNABLE_TO_CALL_TIMEOUT = 'Unable to call timeout.';
export var CONTRACT_IS_NOT_WAITING_ON_OTHER_PARTY = 'Unable to call timeout, because the contract is not waiting on the other party.';
export var TIMEOUT_NOT_REACHED = 'Unable to call timeout, because it has not been reached yet.';

// AbstractContract
export var NO_ARBITRATOR_IMPLEMENTATION_SPECIFIED = 'No Arbitrator Contract Implementation specified. Please call setArbitrator.';
export var NO_ARBITRABLE_IMPLEMENTATION_SPECIFIED = 'No Arbitrable Contract Implementation specified. Please call setArbitrable.';
export var NO_STORE_PROVIDER_SPECIFIED = 'No Store Provider Specified. Please call setStoreProvider';

// Disputes
export var NO_STORE_DATA_FOR_DISPUTE = function NO_STORE_DATA_FOR_DISPUTE(account) {
  return 'Account ' + account + ' does not have store data for dispute';
};

// Notifications
export var MISSING_STORE_PROVIDER = 'This method requires the use of an off chain store. Please call setStoreProviderInstance.';

// Event Listener
export var MISSING_CONTRACT_INSTANCE = function MISSING_CONTRACT_INSTANCE(contractAddress) {
  return 'No contract instance stored for ' + contractAddress + '. Please call addContractInstance.';
};
export var ERROR_FETCHING_EVENTS = function ERROR_FETCHING_EVENTS(error) {
  return 'Unable to fetch events: ' + error;
};

// Auth
export var UNABLE_TO_SIGN_TOKEN = 'There was an error signing the auth token. Please try again';
export var INVALID_AUTH_TOKEN = function INVALID_AUTH_TOKEN(msg) {
  return 'Authorization Token is invalid: ' + msg;
};
//# sourceMappingURL=error.js.map