import _regeneratorRuntime from 'babel-runtime/regenerator';
import _asyncToGenerator from 'babel-runtime/helpers/asyncToGenerator';
import _Object$getPrototypeOf from 'babel-runtime/core-js/object/get-prototype-of';
import _classCallCheck from 'babel-runtime/helpers/classCallCheck';
import _possibleConstructorReturn from 'babel-runtime/helpers/possibleConstructorReturn';
import _inherits from 'babel-runtime/helpers/inherits';
import AbstractContract from '../AbstractContract';

/**
 * Arbitrable Abstract Contarct API. This wraps an arbitrable contract. It provides
 * interaction with both the off chain store as well as the arbitrable instance. All
 * arbitrable methods from the supplied contract implementation can be called from this
 * object.
 */

var ArbitrableContract = function (_AbstractContract) {
  _inherits(ArbitrableContract, _AbstractContract);

  function ArbitrableContract() {
    var _ref,
        _this2 = this;

    var _temp, _this, _ret;

    _classCallCheck(this, ArbitrableContract);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = ArbitrableContract.__proto__ || _Object$getPrototypeOf(ArbitrableContract)).call.apply(_ref, [this].concat(args))), _this), _this.submitEvidence = function () {
      var _ref2 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(account, arbitrableTransactionId, name, description, url, hash) {
        var contractAddress, evidenceIndex, evidenceUri, txHash;
        return _regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                contractAddress = _this._contractImplementation.contractAddress;

                // get the index of the new evidence

                _context.next = 3;
                return _this._StoreProvider.addEvidenceContract(contractAddress, arbitrableTransactionId, account, name, description, url, hash);

              case 3:
                evidenceIndex = _context.sent;


                // construct the unique URI
                evidenceUri = _this._StoreProvider.getEvidenceUri(account, contractAddress, arbitrableTransactionId, evidenceIndex);
                _context.next = 7;
                return _this._contractImplementation.submitEvidence(account, arbitrableTransactionId, evidenceUri);

              case 7:
                txHash = _context.sent;
                return _context.abrupt('return', txHash);

              case 9:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, _this2);
      }));

      return function (_x, _x2, _x3, _x4, _x5, _x6) {
        return _ref2.apply(this, arguments);
      };
    }(), _temp), _possibleConstructorReturn(_this, _ret);
  }
  /**
   * Submit evidence. FIXME should we determine the hash for the user?
   * @param {string} account - ETH address of user.
   * @param {string} arbitrableTransactionId - Id of the arbitrable transaction.
   * @param {string} name - Name of evidence.
   * @param {string} description - Description of evidence.
   * @param {string} url - A link to an evidence using its URI.
   * @param {string} hash - A hash of the evidence at the URI. No hash if content is dynamic
   * @returns {string} - txHash Hash transaction.
   */


  return ArbitrableContract;
}(AbstractContract);

export default ArbitrableContract;
//# sourceMappingURL=MultipleArbitrable.js.map