import _regeneratorRuntime from 'babel-runtime/regenerator';
import _asyncToGenerator from 'babel-runtime/helpers/asyncToGenerator';
import _Object$getPrototypeOf from 'babel-runtime/core-js/object/get-prototype-of';
import _classCallCheck from 'babel-runtime/helpers/classCallCheck';
import _possibleConstructorReturn from 'babel-runtime/helpers/possibleConstructorReturn';
import _inherits from 'babel-runtime/helpers/inherits';
import ArbitrablePermissionListArtifact from 'kleros-interaction/build/contracts/ArbitrablePermissionList';

import Arbitrable from './Arbitrable';

/**
 * Provides interaction with an Arbitrable Transaction contract deployed on the blockchain.
 */

var ArbitrablePermissionList = function (_Arbitrable) {
  _inherits(ArbitrablePermissionList, _Arbitrable);

  /**
   * Constructor ArbitrableTransaction.
   * @param {object} web3Provider instance
   * @param {string} contractAddress of the contract
   */
  function ArbitrablePermissionList(web3Provider, contractAddress) {
    var _this2 = this;

    _classCallCheck(this, ArbitrablePermissionList);

    var _this = _possibleConstructorReturn(this, (ArbitrablePermissionList.__proto__ || _Object$getPrototypeOf(ArbitrablePermissionList)).call(this, web3Provider, ArbitrablePermissionListArtifact, contractAddress));

    _this.getItemByDisputeId = function () {
      var _ref = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(disputeID) {
        return _regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return _this.loadContract();

              case 2:
                return _context.abrupt('return', _this.contractInstance.disputeIDToItem(disputeID));

              case 3:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, _this2);
      }));

      return function (_x) {
        return _ref.apply(this, arguments);
      };
    }();

    return _this;
  }

  /**
   * Fetch an item hash by disputeID
   * @param {number} disputeID The index of the dispute.
   * @returns {string} The item hash.
   */


  return ArbitrablePermissionList;
}(Arbitrable);

export default ArbitrablePermissionList;
//# sourceMappingURL=ArbitrablePermissionList.js.map