'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _AbstractContract2 = require('../AbstractContract');

var _AbstractContract3 = _interopRequireDefault(_AbstractContract2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Arbitrable Abstract Contarct API. This wraps an arbitrable contract. It provides
 * interaction with both the off chain store as well as the arbitrable instance. All
 * arbitrable methods from the supplied contract implementation can be called from this
 * object.
 */
var ArbitrableContract = function (_AbstractContract) {
  (0, _inherits3.default)(ArbitrableContract, _AbstractContract);

  function ArbitrableContract() {
    var _ref,
        _this2 = this;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, ArbitrableContract);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = ArbitrableContract.__proto__ || (0, _getPrototypeOf2.default)(ArbitrableContract)).call.apply(_ref, [this].concat(args))), _this), _this.submitEvidence = function () {
      var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(account, arbitrableTransactionId, name, description, url, hash) {
        var contractAddress, evidenceIndex, evidenceUri, txHash;
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                contractAddress = _this._contractImplementation.contractAddress;

                // get the index of the new evidence

                _context.next = 3;
                return _this._StoreProvider.addEvidenceContract(contractAddress, arbitrableTransactionId, account, name, description, url, hash);

              case 3:
                evidenceIndex = _context.sent;


                // construct the unique URI
                evidenceUri = _this._StoreProvider.getEvidenceUri(account, contractAddress, arbitrableTransactionId, evidenceIndex);
                _context.next = 7;
                return _this._contractImplementation.submitEvidence(account, arbitrableTransactionId, evidenceUri);

              case 7:
                txHash = _context.sent;
                return _context.abrupt('return', txHash);

              case 9:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, _this2);
      }));

      return function (_x, _x2, _x3, _x4, _x5, _x6) {
        return _ref2.apply(this, arguments);
      };
    }(), _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }
  /**
   * Submit evidence. FIXME should we determine the hash for the user?
   * @param {string} account - ETH address of user.
   * @param {string} arbitrableTransactionId - Id of the arbitrable transaction.
   * @param {string} name - Name of evidence.
   * @param {string} description - Description of evidence.
   * @param {string} url - A link to an evidence using its URI.
   * @param {string} hash - A hash of the evidence at the URI. No hash if content is dynamic
   * @returns {string} - txHash Hash transaction.
   */


  return ArbitrableContract;
}(_AbstractContract3.default);

exports.default = ArbitrableContract;
//# sourceMappingURL=MultipleArbitrable.js.map