'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _error = require('../constants/error');

/**
 * Used as the default parameter for an arguemnt that is considered required. It will
 * throw an error if the argument is not supplied by the user.
 * @param {string} name - The name of the missing argument.
 */
var isRequired = function isRequired(name) {
  throw new Error((0, _error.MISSING_PARAMETERS)(name));
};

exports.default = isRequired;
//# sourceMappingURL=isRequired.js.map